#include "betalupi_ergodox.h"


#ifdef SWAP_HANDS_ENABLE
	__attribute__ ((weak))
	// swap-hands action needs a matrix to define the swap
	const keypos_t hand_swap_config[MATRIX_ROWS][MATRIX_COLS] = {
		/* Left hand, matrix positions */
		{{0,13}, {1,13}, {2,13}, {3,13}, {4,13}, {5,13}},
		{{0,12}, {1,12}, {2,12}, {3,12}, {4,12}, {5,12}},
		{{0,11}, {1,11}, {2,11}, {3,11}, {4,11}, {5,11}},
		{{0,10}, {1,10}, {2,10}, {3,10}, {4,10}, {5,10}},
		{{0,9}, {1,9}, {2,9}, {3,9}, {4,9}, {5,9}},
		{{0,8}, {1,8}, {2,8}, {3,8}, {4,8}, {5,8}},
		{{0,7}, {1,7}, {2,7}, {3,7}, {4,7}, {5,7}},
		/* Right hand, matrix positions */
		{{0,6}, {1,6}, {2,6}, {3,6}, {4,6}, {5,6}},
		{{0,5}, {1,5}, {2,5}, {3,5}, {4,5}, {5,5}},
		{{0,4}, {1,4}, {2,4}, {3,4}, {4,4}, {5,4}},
		{{0,3}, {1,3}, {2,3}, {3,3}, {4,3}, {5,3}},
		{{0,2}, {1,2}, {2,2}, {3,2}, {4,2}, {5,2}},
		{{0,1}, {1,1}, {2,1}, {3,1}, {4,1}, {5,1}},
		{{0,0}, {1,0}, {2,0}, {3,0}, {4,0}, {5,0}},
	};
#endif


#ifdef RGB_MATRIX_ENABLE
	void suspend_power_down_kb(void) {
		rgb_matrix_set_suspend_state(true);
		suspend_power_down_user();
	}

	void suspend_wakeup_init_kb(void) {
		rgb_matrix_set_suspend_state(false);
		suspend_wakeup_init_user();
	}

	const is31_led g_is31_leds[RGB_MATRIX_LED_COUNT] = {
		//{driver, R location, G location, B location}

		{0, C3_1,  C2_1,  C4_1}, // LED1 on right
		{0, C6_1,  C5_1,  C7_1}, // LED2
		{0, C4_2,  C3_2,  C5_2}, // LED3
		{0, C7_2,  C6_2,  C8_2}, // LED4
		{0, C2_3,  C1_3,  C3_3}, // LED5
		{0, C5_3,  C4_3,  C6_3}, // LED6
		{0, C8_3,  C7_3,  C9_3}, // LED7
		{0, C2_4,  C1_4,  C3_4}, // LED8
		{0, C6_4,  C5_4,  C7_4}, // LED9
		{0, C2_5,  C1_5,  C3_5}, // LED10
		{0, C7_5,  C6_5,  C8_5}, // LED11
		{0, C2_6,  C1_6,  C3_6}, // LED12
		{0, C5_6,  C4_6,  C6_6}, // LED13
		{0, C8_6,  C7_6,  C9_6}, // LED14
		{0, C2_7,  C1_7,  C3_7}, // LED15
		{0, C5_7,  C4_7,  C6_7}, // LED16
		{0, C2_8,  C1_8,  C3_8}, // LED17
		{0, C5_8,  C4_8,  C6_8}, // LED18

		{0, C3_9,  C2_9,  C4_9}, // LED19
		{0, C6_9,  C5_9,  C7_9}, // LED20
		{0, C4_10, C3_10, C5_10}, // LED21
		{0, C7_10, C6_10, C8_10}, // LED22
		{0, C2_11, C1_11, C3_11}, // LED23
		{0, C5_11, C4_11, C6_11}, // LED24

		{1, C3_1,  C2_1,  C4_1}, // LED1 on left
		{1, C6_1,  C5_1,  C7_1}, // LED2
		{1, C4_2,  C3_2,  C5_2}, // LED3
		{1, C7_2,  C6_2,  C8_2}, // LED4
		{1, C2_3,  C1_3,  C3_3}, // LED5
		{1, C5_3,  C4_3,  C6_3}, // LED6
		{1, C8_3,  C7_3,  C9_3}, // LED7
		{1, C2_4,  C1_4,  C3_4}, // LED8
		{1, C6_4,  C5_4,  C7_4}, // LED9
		{1, C2_5,  C1_5,  C3_5}, // LED10
		{1, C7_5,  C6_5,  C8_5}, // LED11
		{1, C2_6,  C1_6,  C3_6}, // LED12
		{1, C5_6,  C4_6,  C6_6}, // LED13
		{1, C8_6,  C7_6,  C9_6}, // LED14
		{1, C2_7,  C1_7,  C3_7}, // LED15
		{1, C5_7,  C4_7,  C6_7}, // LED16
		{1, C2_8,  C1_8,  C3_8}, // LED17
		{1, C5_8,  C4_8,  C6_8}, // LED18

		{1, C3_9,  C2_9,  C4_9}, // LED19
		{1, C6_9,  C5_9,  C7_9}, // LED20
		{1, C4_10, C3_10, C5_10}, // LED21
		{1, C7_10, C6_10, C8_10}, // LED22
		{1, C2_11, C1_11, C3_11}, // LED23
		{1, C5_11, C4_11, C6_11} // LED24
	};


	led_config_t g_led_config = { {
		// Key matrix to LED index
		{ NO_LED, NO_LED, NO_LED, NO_LED, NO_LED, NO_LED },
		{  28,  33,  38,  43,  47, NO_LED },
		{  27,  32,  37,  42,  46, NO_LED },
		{  26,  31,  36,  41,  45, NO_LED },
		{  25,  30,  35,  40,  44, NO_LED },
		{  24,  29,  34,  39, NO_LED, NO_LED },
		{ NO_LED, NO_LED, NO_LED, NO_LED, NO_LED, NO_LED },
		{ NO_LED, NO_LED, NO_LED, NO_LED, NO_LED, NO_LED },
		{   0,   5,  10,  15, NO_LED, NO_LED },
		{   1,   6,  11,  16,  20, NO_LED },
		{   2,   7,  12,  17,  21, NO_LED },
		{   3,   8,  13,  18,  22, NO_LED },
		{   4,   9,  14,  19,  23, NO_LED },
		{ NO_LED, NO_LED, NO_LED, NO_LED, NO_LED, NO_LED }
	}, {
		// LED index to physical position
		{ 137,   0 }, { 154,   0 }, { 172,   0 }, { 189,   0 }, { 206,   0 }, { 137,  12 },
		{ 154,  12 }, { 172,  12 }, { 189,  12 }, { 206,  12 }, { 137,  25 }, { 154,  25 },
		{ 172,  25 }, { 189,  25 }, { 206,  25 }, { 137,  38 }, { 154,  38 }, { 172,  38 },
		{ 189,  38 }, { 206,  38 }, { 154,  51 }, { 172,  51 }, { 189,  51 }, { 206,  51 },
		{  86,   0 }, {  68,   0 }, {  51,   0 }, {  34,   0 }, {  17,   0 }, {  86,  12 },
		{  68,  12 }, {  51,  12 }, {  34,  12 }, {  17,  12 }, {  86,  25 }, {  68,  25 },
		{  51,  25 }, {  34,  25 }, {  17,  25 }, {  86,  38 }, {  68,  38 }, {  51,  38 },
		{  34,  38 }, {  17,  38 }, {  68,  51 }, {  51,  51 }, {  34,  51 }, {  17,  51 }
	}, {
		// LED index to flag
		4, 4, 4, 4, 4, 4,
		4, 4, 4, 4, 4, 4,
		4, 4, 4, 4, 4, 4,
		4, 4, 1, 1, 1, 1,
		4, 4, 4, 4, 4, 4,
		4, 4, 4, 4, 4, 4,
		4, 4, 4, 4, 4, 4,
		4, 4, 1, 1, 1, 1
	} };
#endif